=== modified file 'data/install.ui'
--- data/install.ui	2010-12-24 14:53:03 +0000
+++ data/install.ui	2011-01-06 19:47:25 +0000
@@ -23,11 +23,12 @@
         <property name="visible">True</property>
         <child>
           <object class="GtkButton" id="install_button">
-            <property name="label">gtk-ok</property>
+            <property name="label" translatable="yes">_Install now</property>
             <property name="visible">True</property>
             <property name="can_focus">True</property>
             <property name="receives_default">True</property>
-            <property name="use_stock">True</property>
+            <property name="image">image1</property>
+            <property name="use_underline">True</property>
             <signal name="clicked" handler="on_install_button_clicked"/>
           </object>
           <packing>
@@ -43,4 +44,8 @@
       </packing>
     </child>
   </object>
+  <object class="GtkImage" id="image1">
+    <property name="visible">True</property>
+    <property name="stock">gtk-ok</property>
+  </object>
 </interface>

=== modified file 'pylintrc'
--- pylintrc	2010-10-13 18:55:23 +0000
+++ pylintrc	2011-01-06 19:47:25 +0000
@@ -272,7 +272,7 @@
 max-line-length=79
 
 # Maximum number of lines in a module
-max-module-lines=2000
+max-module-lines=2500
 
 # String used as indentation unit. This is usually " " (4 spaces) or "\t" (1
 # tab).

=== modified file 'ubuntuone/controlpanel/gtk/gui.py'
--- ubuntuone/controlpanel/gtk/gui.py	2011-01-05 21:04:07 +0000
+++ ubuntuone/controlpanel/gtk/gui.py	2011-01-06 19:47:25 +0000
@@ -78,6 +78,7 @@
 VALUE_ERROR = _('Value could not be retrieved.')
 WARNING_MARKUP = '<span foreground="%s"><b>%%s</b></span>' % ORANGE
 KILOBYTES = 1024
+NO_OP = lambda *a, **kw: None
 
 
 def filter_by_app_name(f):
@@ -352,7 +353,8 @@
         settings = {TC_URL_KEY: U1_TC_URL, HELP_TEXT_KEY: U1_DESCRIPTION,
                     WINDOW_ID_KEY: str(self._window_id),
                     PING_URL_KEY: U1_PING_URL}
-        self.sso_backend.register(U1_APP_NAME, settings)
+        self.sso_backend.register(U1_APP_NAME, settings,
+            reply_handler=NO_OP, error_handler=NO_OP)
         self.set_property('greyed', True)
         self.warning_label.set_text('')
 
@@ -361,7 +363,8 @@
         settings = {TC_URL_KEY: U1_TC_URL, HELP_TEXT_KEY: U1_DESCRIPTION,
                     WINDOW_ID_KEY: str(self._window_id),
                     PING_URL_KEY: U1_PING_URL}
-        self.sso_backend.login(U1_APP_NAME, settings)
+        self.sso_backend.login(U1_APP_NAME, settings,
+            reply_handler=NO_OP, error_handler=NO_OP)
         self.set_property('greyed', True)
         self.warning_label.set_text('')
 
@@ -408,7 +411,8 @@
         else:
             self.set_sensitive(True)
             self.warning_label.set_text('')
-            self.sso_backend.find_credentials(U1_APP_NAME, {})
+            self.sso_backend.find_credentials(U1_APP_NAME, {},
+                reply_handler=NO_OP, error_handler=NO_OP)
 
 
 class DashboardPanel(UbuntuOneBin, ControlPanelMixin):
@@ -516,11 +520,12 @@
         volume_id = checkbutton.get_label()
         subscribed = bool_str(checkbutton.get_active())
         self.backend.change_volume_settings(volume_id,
-                                            {'subscribed': subscribed})
+            {'subscribed': subscribed},
+            reply_handler=NO_OP, error_handler=NO_OP)
 
     def load(self):
         """Load the volume list."""
-        self.backend.volumes_info()
+        self.backend.volumes_info(reply_handler=NO_OP, error_handler=NO_OP)
         self.message.start()
 
 
@@ -565,7 +570,8 @@
         # Not disabling the GUI to avoid annyong twitchings
         #self.set_sensitive(False)
         self.warning_label.set_text('')
-        self.backend.change_device_settings(self.id, self.__dict__)
+        self.backend.change_device_settings(self.id, self.__dict__,
+            reply_handler=NO_OP, error_handler=NO_OP)
 
     def _block_signals(f):
         """Execute 'f' while having the _updating flag set."""
@@ -591,7 +597,8 @@
 
     def on_remove_clicked(self, widget):
         """Remove button was clicked or activated."""
-        self.backend.remove_device(self.id)
+        self.backend.remove_device(self.id,
+            reply_handler=NO_OP, error_handler=NO_OP)
         self.set_sensitive(False)
 
     @_block_signals
@@ -747,7 +754,7 @@
 
     def load(self):
         """Load the device list."""
-        self.backend.devices_info()
+        self.backend.devices_info(reply_handler=NO_OP, error_handler=NO_OP)
         self.message.start()
 
 
@@ -845,11 +852,13 @@
                          name=self.FILES_SERVICE_NAME)
 
         self.set_sensitive(False)
+
         self.backend.connect_to_signal('FileSyncStatusChanged',
                                        self.on_file_sync_status_changed)
         self.backend.connect_to_signal('FilesEnabled', self.on_files_enabled)
         self.backend.connect_to_signal('FilesDisabled', self.on_files_disabled)
-        self.backend.file_sync_status()
+
+        self.backend.file_sync_status(reply_handler=NO_OP, error_handler=NO_OP)
 
     @log_call(logger.debug)
     def on_file_sync_status_changed(self, status):
@@ -875,9 +884,11 @@
         """Button was toggled, exclude/replicate the service properly."""
         logger.info('File sync enabled? %r', self.button.get_active())
         if self.button.get_active():
-            self.backend.enable_files()
+            self.backend.enable_files(reply_handler=NO_OP,
+                                      error_handler=NO_OP)
         else:
-            self.backend.disable_files()
+            self.backend.disable_files(reply_handler=NO_OP,
+                                       error_handler=NO_OP)
 
 
 class DesktopcouchService(Service):
@@ -915,7 +926,8 @@
                     self.id, self.button.get_active())
 
         args = {'enabled': bool_str(self.button.get_active())}
-        self.backend.change_replication_settings(self.id, args)
+        self.backend.change_replication_settings(self.id, args,
+            reply_handler=NO_OP, error_handler=NO_OP)
 
     @log_call(logger.info)
     def on_replication_settings_changed(self, replication_id):
@@ -993,7 +1005,8 @@
         """Load replications info."""
         # ask replications to the backend
         self.message.start()
-        self.backend.replications_info()
+        self.backend.replications_info(reply_handler=NO_OP,
+                                       error_handler=NO_OP)
 
     @log_call(logger.debug)
     def on_replications_info_ready(self, info):
@@ -1020,7 +1033,11 @@
     @log_call(logger.error)
     def on_replications_info_error(self, error_dict=None):
         """The replication info can not be retrieved."""
-        self.on_error(self.NO_PAIRING_RECORD)
+        if error_dict is not None and \
+           error_dict.get('error_type', None) == 'NoPairingRecord':
+            self.on_error(self.NO_PAIRING_RECORD)
+        else:
+            self.on_error()
 
 
 class ManagementPanel(gtk.VBox, ControlPanelMixin):
@@ -1113,8 +1130,8 @@
 
     def load(self):
         """Load the account info and file sync status list."""
-        self.backend.account_info()
-        self.backend.file_sync_status()
+        self.backend.account_info(reply_handler=NO_OP, error_handler=NO_OP)
+        self.backend.file_sync_status(reply_handler=NO_OP, error_handler=NO_OP)
         self.dashboard_button.clicked()
 
     @log_call(logger.debug)

=== modified file 'ubuntuone/controlpanel/gtk/tests/test_gui.py'
--- ubuntuone/controlpanel/gtk/tests/test_gui.py	2011-01-05 21:04:07 +0000
+++ ubuntuone/controlpanel/gtk/tests/test_gui.py	2011-01-06 19:47:25 +0000
@@ -38,6 +38,8 @@
 
 # Attribute 'yyy' defined outside __init__, access to a protected member
 # pylint: disable=W0201, W0212
+# Too many lines in module
+# pylint: disable=C0302
 
 
 class BaseTestCase(TestCase):
@@ -97,7 +99,8 @@
         if backend is None:
             backend = self.ui.backend
         self.assertIn(method_name, backend._called)
-        self.assertEqual(backend._called[method_name], (args, {}))
+        kwargs = {'reply_handler': gui.NO_OP, 'error_handler': gui.NO_OP}
+        self.assertEqual(backend._called[method_name], (args, kwargs))
 
     def assert_warning_correct(self, warning, text):
         """Check that 'warning' is visible, showing 'text'."""
@@ -1755,16 +1758,41 @@
     def setUp(self):
         super(ServicesWithDesktopcouchErrorTestCase, self).setUp()
         self.ui.package_manager._installed[self.ui.DESKTOPCOUCH_PKG] = True
-        self.ui.on_replications_info_error(error_dict={})
 
     def test_no_pairing_record(self):
         """The pairing record is not in place."""
-        # should fake a NoPairingRecord error,
-        # right now every error is no pairing record
+        error_dict = {'error_type': 'NoPairingRecord'}
+        self.ui.on_replications_info_error(error_dict)
+
         self.assertEqual(self.ui.replications.get_children(), [])
         self.assertFalse(self.ui.message.active)
         self.assert_warning_correct(self.ui.message, self.ui.NO_PAIRING_RECORD)
 
+    def test_other_error(self):
+        """There was an error other than no pairing record."""
+        error_dict = {'error_type': 'OtherError'}
+        self.ui.on_replications_info_error(error_dict)
+
+        self.assertEqual(self.ui.replications.get_children(), [])
+        self.assertFalse(self.ui.message.active)
+        self.assert_warning_correct(self.ui.message, gui.VALUE_ERROR)
+
+    def test_empty_dict(self):
+        """Handle empty dicts errors."""
+        self.ui.on_replications_info_error(error_dict={})
+
+        self.assertEqual(self.ui.replications.get_children(), [])
+        self.assertFalse(self.ui.message.active)
+        self.assert_warning_correct(self.ui.message, gui.VALUE_ERROR)
+
+    def test_error_dict_none(self):
+        """HGandle empty dicts errors."""
+        self.ui.on_replications_info_error(error_dict=None)
+
+        self.assertEqual(self.ui.replications.get_children(), [])
+        self.assertFalse(self.ui.message.active)
+        self.assert_warning_correct(self.ui.message, gui.VALUE_ERROR)
+
 
 class ManagementPanelTestCase(ControlPanelMixinTestCase):
     """The test suite for the management panel."""

=== modified file 'ubuntuone/controlpanel/replication_client.py'
--- ubuntuone/controlpanel/replication_client.py	2011-01-05 21:04:07 +0000
+++ ubuntuone/controlpanel/replication_client.py	2011-01-06 19:47:25 +0000
@@ -18,7 +18,7 @@
 
 """Client to use replication services."""
 
-from twisted.internet.defer import inlineCallbacks, returnValue
+from twisted.internet.defer import Deferred, inlineCallbacks, returnValue
 
 from ubuntuone.controlpanel.logger import setup_logging
 
@@ -51,9 +51,9 @@
     """The replication can not be excluded since is already excluded."""
 
 
-@inlineCallbacks
 def get_replication_proxy(replication_module=None):
     """Return a proxy to the replication client."""
+    d = Deferred()
     if replication_module is None:
         # delay import in case DC is not installed at module import time
         # Unable to import 'desktopcouch.application.replication_services'
@@ -61,12 +61,13 @@
         from desktopcouch.application.replication_services \
             import ubuntuone as replication_module
     try:
-        result = yield replication_module.ReplicationExclusion()
+        result = replication_module.ReplicationExclusion()
     except ValueError:
-        raise NoPairingRecord()
+        d.errback(NoPairingRecord())
     else:
-        returnValue(result)
-    assert result is not None
+        d.callback(result)
+
+    return d
 
 
 @inlineCallbacks
@@ -80,7 +81,7 @@
 def get_exclusions():
     """Retrieve the list of exclusions."""
     proxy = yield get_replication_proxy()
-    result = yield proxy.all_exclusions()
+    result = proxy.all_exclusions()
     returnValue(result)
 
 

